<?php 
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {   # display source of script if requested so
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header('Content-type: text/html; charset=utf-8' );
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
header('Content-type: text/html; charset=utf-8' );
#
# test script to display information retrieved by CURL VERSION 2 incl error and return codes
#
ini_set('display_errors', 'On'); 	// set all error checking on
error_reporting(E_ALL & ~E_NOTICE);
#
$frame  = false;                        // display an iframe to test load locally
$use_ip = false;                        // use dns or skip dns and use direct ip address
$wait   = 10;                           // max wait time for connect
$length	= 500;				// max length of data to be displayed outside iframe
$lat    = '52.39';   
$lon    = '4.94';
#
#Array of URLs to test
#
if (isset ($use_ip) && $use_ip == true) {
        $arrRead['meteoalarm'] 	= array('link' => 'http://81.31.132.75/en_UK/0/0/NL015.html?lang=en',              'txt'	=> 'weather warnings');
        $arrRead['temis_uv']    = array('link' => 'http://145.23.254.72/uvradiation/nrt/uvindex.php?lon=4.94&lat=52.39', 'txt'	=> 'UV forcast');
        $arrRead['knmi']        = array('link' => 'ftp://145.23.253.248/pub_weerberichten/weeroverzicht.xml',                    'txt'	=> 'KNMI forcast');
}
else {  $arrRead['meteoalarm'] 	= array('link' => 'http://www.meteoalarm.eu/en_UK/0/0/NL015.html?lang=en',              'txt'	=> 'weather warnings');
        $arrRead['temis_uv']    = array('link' => 'http://www.temis.nl/uvradiation/nrt/uvindex.php?lon=4.94&lat=52.39', 'txt'	=> 'UV forcast');
        $arrRead['knmi']        = array('link' => 'ftp.knmi.nl/pub_weerberichten/weeroverzicht.xml',                    'txt'	=> 'KNMI forcast');
}
#
# Display all URLs in iframe and as retrieved by CURL on server.
#
foreach ($arrRead as $key => $arr) {
#
        $link	= $arr['link'];
        
        if ($frame) {
        # first display iframe so that the link is executed in the visiors browser  
                echo '<hr /><p>The link below retrieves '.$arr['txt'].'<br /><small>'.$link.'</small><br /></p>

<iframe src="'.$link.'" style ="width:95%; height: 200px; padding: 10px;border: 5px black solid; background: transparent; vertical-align: bottom;">
iframe
</iframe>'.PHP_EOL;
        }
        flush();
        ob_flush();
#
# Now do a CURL to retrieve the same information
#
	echo 'Following  link retrieves '.$arr['txt'].' and is executed on your server:<br /><a href="'.$link.'">'.$link.'</a><br />
WAIT TIME '.$wait.' seconds max<br /></p>';

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $link);
        curl_setopt ($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
#	curl_setopt ($ch,139, 80);
#       curl_setopt ($ch, CURLOPT_LOCALPORT, 80);
	curl_setopt ($ch, CURLOPT_FILETIME, 1);
	curl_setopt ($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
	curl_setopt ($ch, CURLOPT_TIMEOUT, $wait);
	$rawData = curl_exec ($ch);

	echo '<p><b>Return</b> codes: <pre>';
	$info	= curl_getinfo($ch);
	print_r ($info);
	echo '</pre></p>'.PHP_EOL;
	
	$errors = curl_error($ch);
	curl_close ($ch);
	unset ($ch);
		
	echo '<p><b>Error</b> codes: '.$errors.'</p>'.PHP_EOL;
	if (strlen($rawData) < 2) { 
		echo '<p><b>No data</b> was retrieved for '.$link.'</p>'.PHP_EOL;
		echo '<hr >';
		continue;
	}	
	$from 	= array('<','>');
	$to	= array('&lt;','&gt;');
	$string = str_replace ($from, $to, $rawData);
	echo '<p><b>Data</b> returned (maximum first '.$length.' characters displayed)</p><pre>'.substr($string,0,$length).'</pre>'.PHP_EOL;
        echo '<hr >';
}
echo '<hr ><h3 style="color: red;">To check the code of this script, add <span style="color: black;">?sce=view</span>  to the url and the script will display itself</h3>';
